import numpy as np
import cPickle as pickle
import pylab as plt

L=12.013

t=pickle.load(file('t','r'))
ke=pickle.load(file('ke','r'))
pe=pickle.load(file('pe','r'))
excpe=pickle.load(file('excpe','r'))
allpos=pickle.load(file('allpos','r'))

          
al=open('alpdf','w')
y=open('ypdf','w')
o=open('opdf','w')
kefile=open('kedata','w')
pefile=open('pedata','w')
excpefile=open('excpedata','w')

print 'avg ke ', np.average(ke), 'avg pe', np.average(pe), 'avg excpe', np.average(excpe)

plt.plot(t,ke)
plt.show()

#allpos=allpos[:160*(3),:]
numpos = np.shape(allpos)[0]/160
print numpos, np.shape(allpos)

avgpos=np.zeros((160,3),float)

##generate array of average positions
for i in range(numpos-1):
    avgpos=avgpos+allpos[i*160:(i-numpos+1)*160,:]/numpos
avgpos=avgpos+allpos[-160:,:]/numpos

## pair dist function around Ce
PDFmin=1.5
PDFmax=5.5
PDFrange=PDFmax-PDFmin
bins=400
width=PDFrange/bins
dist=np.array(range(bins))*width+PDFmin
alcounts=np.zeros(bins)
ycounts=np.zeros(bins)
ocounts=np.zeros(bins)

print width

pcfreq=300

for z in range(numpos-1):
    if z%pcfreq == 0:
        print z/float(numpos-1)*100, '% done'
    curpos=allpos[z*160:(z-numpos+1)*160,:]
    cepos=curpos[16,:]
    #pdf for al
    #octahedral al
    for i in range(16):
        rij=cepos-curpos[i,:]
        rij=rij-L*np.round_(rij/L)
        d=(np.sum(rij*rij))**0.5
        for q in range(bins):
            if d>(q*width+PDFmin) and d<=((q+1)*width+PDFmin):
                alcounts[q]+=1
    
    #tetrahedral al
    for i in range(24):
        rij=cepos-curpos[i+39,:]
        rij=rij-L*np.round_(rij/L)
        d=np.sum(rij*rij)**0.5
        for q in range(bins):
            if d>(q*width+PDFmin) and d<=((q+1)*width+PDFmin):
                alcounts[q]+=1
    
    #pdf for y
    for i in range(23):
        rij=cepos-curpos[i+16,:]
        rij=rij-L*np.round_(rij/L)
        d=np.sum(rij*rij)**0.5
        for q in range(bins):
            if d>(q*width+PDFmin) and d<=((q+1)*width+PDFmin):
                ycounts[q]+=1
        
    #and most importantly...pdf for o
    for i in range(96):
        rij=cepos-curpos[i+63,:]
        rij=rij-L*np.round_(rij/L)
        d=np.sum(rij*rij)**0.5
        for q in range(bins):
            if d>(q*width+PDFmin) and d<=((q+1)*width+PDFmin):
                ocounts[q]+=1

for i in range(15000):
    kefile.write(str(t[20000+i]) + '\t' + str(ke[20000+i]) + '\n')
    pefile.write(str(t[20000+i]) + '\t' + str(pe[20000+i]) + '\n')
    excpefile.write(str(t[20000+i]) + '\t' + str(excpe[20000+i]) + '\n')
    
for i in range(len(dist)):
    al.write(str(dist[i]) + '\t' + str(alcounts[i]) + '\n')
    y.write(str(dist[i]) + '\t' + str(ycounts[i]) + '\n')
    o.write(str(dist[i]) + '\t' + str(ocounts[i]) + '\n')
          
al.close()
y.close()
o.close()
kefile.close()
pefile.close()
excpefile.close()
          
plt.plot(dist,alcounts,marker='o',color='blue')
plt.plot(dist,ycounts,marker='o',color='black')
plt.plot(dist,ocounts,marker='o',color='red')

plt.show()